/* 
   manae --- skimple kana MANA Exchanger
   prefs.c.c --- manae's setting preferences module
   Copyright 1998 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

// #include <stdio.h>
// #include <System/SysAll.h>
// #include <System/Graffiti.h>
// #include <UI/UIAll.h>
// #include <System/FeatureMgr.h>

#include <PalmOS.h>
#include "manae.h"
#include "id.h"

// functions in prefsRec.c
Byte PreferencesGetMode(DWord ftrVal);
DWord PreferencesSetMode(Char mode, DWordPtr ftrValP);
Byte PreferencesGetKanjiMode(DWord ftrVal);
DWord PreferencesSetKanjiMode(Char mode, DWordPtr ftrValP);
Boolean PreferencesGetNonSkkMode(DWord ftrVal);
DWord PreferencesSetNonSkkMode(Boolean nonSkk, DWordPtr ftrValP);
Boolean PreferencesGetThumbTypeMode(DWord ftrVal);
DWord PreferencesSetThumbTypeMode(Boolean thumbType, DWordPtr ftrValP);
Byte PreferencesGetGuiMode(DWord ftrVal);
DWord PreferencesSetGuiMode(Byte guiMode, DWordPtr ftrValP);

static VoidPtr GetObjectPtr(Word objectID)
{
  FormPtr frm;
	
  frm = FrmGetActiveForm();
  return (FrmGetObjectPtr(frm, FrmGetObjectIndex (frm, objectID)));
}

static Boolean PreferencesApply()
{
  Byte itemNum, defMode;
  DWord mmMode;
  Boolean flag;
  
  FtrGet(CREATOR, FEATUREMANAEMORI, &mmMode);
  itemNum = LstGetSelection(GetObjectPtr(ID_PREFS_GUI_LIST));
  defMode = LstGetSelection(GetObjectPtr(ID_PREFS_DEF_LIST));
  //  FtrSet(CREATOR, FEATUREMANAEMORI, (DWord)itemNum | (((DWord)defMode) << 24));
  PreferencesSetMode(defMode, &mmMode);
  PreferencesSetGuiMode(itemNum, &mmMode);
  flag = (Boolean)CtlGetValue(GetObjectPtr(ID_PREFS_NON_SKK_CHECKBOX));
  PreferencesSetNonSkkMode(flag, &mmMode);
  flag = (Boolean)CtlGetValue(GetObjectPtr(ID_PREFS_THUMB_TYPE_CHECKBOX));
  PreferencesSetThumbTypeMode(flag, &mmMode);
  FtrSet(CREATOR, FEATUREMANAEMORI, mmMode);
  itemNum = LstGetSelection (GetObjectPtr (ID_PREFS_POP_LIST));
  FtrSet(CREATOR, FEATURECANDSPOPUP, (DWord)itemNum);

  return(true);
}

static Boolean PreferencesInit()
{
  CharPtr label;
  ListPtr lst;
  ControlPtr ctl;
  DWord mode;
  Byte itemNum;
  Boolean flag;

  // Set GUI mode.
  lst = GetObjectPtr(ID_PREFS_GUI_LIST);
  ctl = GetObjectPtr(ID_PREFS_GUI_TRIGGER);

  if (FtrGet(CREATOR, FEATUREMANAEMORI, &mode) != 0) { // Returns 0 if no error.
    FtrSet(CREATOR, FEATUREMANAEMORI, MODEDEFAULT);
    mode = MODEDEFAULT;
  }

  //  itemNum = (Byte)(0x000000ff & mode);
  itemNum = PreferencesGetGuiMode(mode);


  // Set default mode.
  label = LstGetSelectionText(lst, itemNum);
  CtlSetLabel (ctl, label);
  LstSetSelection (lst, itemNum);

  //  itemNum = (Byte)((mode >> 24) & 0x0f);
  itemNum = PreferencesGetMode(mode);

  lst = GetObjectPtr(ID_PREFS_DEF_LIST);
  ctl = GetObjectPtr(ID_PREFS_DEF_TRIGGER);

  label = LstGetSelectionText(lst, itemNum);
  CtlSetLabel(ctl, label);
  LstSetSelection(lst, itemNum);

  // Non-SKK mode
  ctl = GetObjectPtr(ID_PREFS_NON_SKK_CHECKBOX);
  flag = PreferencesGetNonSkkMode(mode);
  CtlSetValue(ctl, (short)flag);

  // Thumb Type mode
  ctl = GetObjectPtr(ID_PREFS_THUMB_TYPE_CHECKBOX);
  flag = PreferencesGetThumbTypeMode(mode);
  CtlSetValue(ctl, (short)flag);

  // Candidates list Popup
  if (FtrGet(CREATOR, FEATURECANDSPOPUP, &mode) != 0) {
    FtrSet(CREATOR, FEATURECANDSPOPUP, POPUPDEFAULT);
    mode = POPUPDEFAULT;
  }

  itemNum = (Byte)(0x000000ff & mode);

  lst = GetObjectPtr(ID_PREFS_POP_LIST);
  ctl = GetObjectPtr(ID_PREFS_POP_TRIGGER);

  label = LstGetSelectionText(lst, itemNum);
  CtlSetLabel(ctl, label);
  LstSetSelection(lst, itemNum);

  return(true);
}

Boolean PrefsHandleEvent(EventPtr event)
{
  Boolean handled = false;
  FormPtr frm;

  if (event->eType == ctlSelectEvent)
    {
      switch (event->data.ctlSelect.controlID)
	{
	case ID_PREFS_BUTTON_DONE:
	  PreferencesApply();
	  FrmGotoForm(9000);
	  handled = true;
	  break;
	  
	case ID_PREFS_BUTTON_INIT:
	  FrmReturnToForm (NULL);
	  handled = true;
	  break;
	  
	}
    }
  
  else if (event->eType == frmOpenEvent)
    {
      frm = FrmGetActiveForm();
      PreferencesInit();
      FrmDrawForm(frm);
      handled = true;
    }
  
  return (handled);
}

